#
# Cookbook:: esh_cinc
# Resource:: download
#
# Copyright:: 2022, https://easyself.host
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

unified_mode true
property :url, String, name_property: true
property :distribution, String, required: true
property :release, String, required: true
default_action :download

action :download do
  distribution = new_resource.distribution
  release = new_resource.release
  filename = new_resource.url.split('/').last

  directory "#{Chef::Config['file_cache_path']}/#{distribution}/#{release}" do
    owner 'root'
    group 'root'
    mode '0755'
    recursive true
    action :create
  end

  remote_file "#{Chef::Config['file_cache_path']}/#{distribution}/#{release}/#{filename}" do
    source new_resource.url
    action :create_if_missing
  end
end
